
#include <stdio.h>
#include <string.h>

int main() { 
  long   a = 12345678912345;   
  double b = 12345678912345.9;
  char c[8] = "1234567";
  printf("a: %ld b: %.3lf c: \"%s\"\n", a,b, c);
   
  // Memory-safe and type-safe
  a = (double) b; // truncation errors possible but well-defined
  b = a;  // long converted to double 
  strcpy(c,"7654321");
  printf("a: %ld b: %.3lf c: \"%s\"\n", a,b, c);
 
  // Memory-safe but not type-safe
  a = * (long*) &b;
  b = * (double*) &main;
  strcpy(c, (char*) &a);  
  printf("a: %ld b: %.3lf c: \"%s\"\n", a,b, c);

  return 0;
}
